# -*- coding: ascii -*-
#
#  Copyright (C) 2001, 2002 by Tamito KAJIYAMA
#  Copyright (C) 2004 by Shyouzou Sugitani <shy@users.sourceforge.jp>
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License (version 2) as
#  published by the Free Software Foundation.  It is distributed in the
#  hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
#  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
#  PURPOSE.  See the GNU General Public License for more details.
#
# $Id: netlib.py,v 1.4 2004/04/13 05:21:59 shy Exp $
#

import os
import select

class Resolver:
    def __init__(self):
        self.command = "ninix-lookup" # may be rewritten
        path = os.environ.get("NINIX") or \
               os.environ.get("NINIX_UPDATE")
        if path is not None:
            path = os.path.join(os.path.dirname(path), self.command)
            if os.path.exists(path):
                self.command = path
        self.pipe = None
    def lookup(self, hostname):
        if self.pipe is None:
            self.pipe = os.popen("%s %s" % (self.command, hostname))
        r, w, e = select.select([self.pipe], [], [], 0)
        if not r:
            return None
        data = self.pipe.read()
        self.pipe.close()
        self.pipe = None
        if data[:2] != "OK":
            return -1
        return data[3:].strip()
